/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_CUTTING_PLANE_H
#define _POLYMAKE_CUTTING_PLANE_H "$Project: polymake $$Id: cutting_plane.h,v 1.6 2004/06/22 16:23:14 gawrilow Exp $"

#include <Rational.h>
#include <Matrix.h>
#include <Vector.h>
#include <IncidenceMatrix.h>
#include <Graph.h>

namespace polymake { namespace polytope {

Vector<Rational>
cutting_plane_via_barycenter(const Matrix<Rational>& V, const Graph<>& G, int vertex_number);

Vector<Rational>
cutting_plane_via_normals(const Matrix<Rational>& V, const Matrix<Rational>& F,
			  const IncidenceMatrix<>& VIF, int vertex_number);

} }

#endif // _POLYMAKE_CUTTING_PLANE_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
