/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_BARYCENTRIC_SUBDIVISION_H
#define _POLYMAKE_BARYCENTRIC_SUBDIVISION_H "$Project: polymake $$Id: barycentric_subdivision.h,v 1.2 2004/06/22 16:22:56 gawrilow Exp $"

#include <HasseDiagram.h>
#include <Array.h>
#include <Set.h>
#include <Matrix.h>
#include <Rational.h>

#include <string>

namespace polymake { namespace topaz {

  // Computes the barycentric subdivision
  Array< Set<int> > bs(const HasseDiagram<>& HD);

  // Computes the VERTEX_LABELS
  Array<std::string> bs_labels(const HasseDiagram<>& HD);

  // Computes the GEOMETRIC_REALIZATION
  Matrix<Rational> bs_geom_real(const Matrix<Rational>& old_coord,
				const HasseDiagram<>& HD);

} }


#endif // _POLYMAKE_BARYCENTRIC_SUBDIVISION_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
