/* Copyright (c) 1997-2005
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_IS_SPHERE_H_H
#define _POLYMAKE_IS_SPHERE_H_H "$Project: polymake $$Id: is_sphere_h.h,v 1.3 2005/09/22 17:12:10 gawrilow Exp $"

#if defined(__GNUC__) && __GNUC__==3 && __GNUC_MINOR__<3 && !defined(__APPLE__) && !defined(__COMO__)
#pragma interface
#endif

#include <BistellarComplex.h>

namespace polymake { namespace topaz {
  
  bool is_sphere_h(const HasseDiagram<>& HD, const int seed, const int strategy, const int n_stable_rounds);

  template<typename Complex>
  bool is_sphere_h(const Complex& C, const int seed, const int strategy, const int n_stable_rounds);
  
  bool is_ball_or_sphere_h(const HasseDiagram<>& HD, const int seed, const int strategy, const int n_stable_rounds);

  template<typename Complex>
  bool is_ball_or_sphere_h(const Complex& C, const int seed, const int strategy, const int n_stable_rounds);
  
} }

#include <is_sphere_h.tcc>

#endif // _POLYMAKE_IS_SPHERE_H_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
