/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: is_sphere_h.tcc,v 1.2 2004/06/22 16:22:56 gawrilow Exp $"

#include <is_sphere_h.h>

namespace polymake { namespace topaz {

template<typename Complex>
bool is_sphere_h(const Complex& C, const int seed, const int strategy, const int n_stable_rounds)
{
   return is_sphere_h(pure_hasse_diagram(C), seed, strategy, n_stable_rounds);
}
  
template<typename Complex>
bool is_ball_or_sphere_h(const Complex& C, const int seed, const int strategy, const int n_stable_rounds)
{
   return is_ball_or_sphere_h(pure_hasse_diagram(C), seed, strategy, n_stable_rounds);
}

} };


// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
