/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_READ_INT_ARGS_H
#define _POLYMAKE_READ_INT_ARGS_H "$Project: polymake $$Id: read_int_args.h,v 1.9 2004/07/27 18:09:42 gawrilow Exp $"

#include <Set.h>

#include <list>

/** Reads integers, specified individually or as a sequence,
 *  e.g. {1 7...9 20} = {1 7 8 9 20}. (perl lovers might use just two
 *  points to indicate a sequence.) 
 */

namespace polymake { namespace topaz { 

Set<int> read_int_args_as_set (const int argc, const char* argv[], const int start_index);

std::list<int> read_int_args_as_list (const int argc, const char* argv[], const int start_index);

} }

#endif // _POLYMAKE_READ_INT_ARGS_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
