/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_READ_STR_ARGS_H
#define _POLYMAKE_READ_STR_ARGS_H "$Project: polymake $$Id: read_str_args.h,v 1.3 2004/06/22 16:22:56 gawrilow Exp $"

#include <string>
#include <list>
#include <Set.h>
#include <Array.h>

/// Reads std::string arguments.

namespace polymake { namespace topaz {

  std::list<std::string> read_str_args (const int argc, const char* argv[], const int start_index);
  
  Set<int> read_label_args (const Array<std::string>& L, const int argc, const char* argv[], const int start_index);
  
  template <typename Labels, typename Args>
  Set<int> transform_label_args (const Labels& L, const Args& labeled_args);
  
} }

#include <read_str_args.tcc>

#endif // _POLYMAKE_READ_STR_ARGS_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
