/* Copyright (c) 1997-2005
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_T_GRAPH_H
#define _POLYMAKE_T_GRAPH_H "$Project: polymake $$Id: t_graph.h,v 1.4 2005/09/22 17:12:10 gawrilow Exp $"

#if defined(__GNUC__) && __GNUC__==3 && __GNUC_MINOR__<3 && !defined(__APPLE__) && !defined(__COMO__)
#pragma interface
#endif

#include <Graph.h>
#include <FacetList.h>

namespace polymake { namespace topaz {

   typedef Graph<> graph;

  // Computes the graph of a simplicial complex.
  template <typename Complex> inline
  graph t_graph(const Complex& C);

  // Computes the dual graph of a simplicial complex.
  graph t_dual_graph(const FacetList& C);

  // Computes the mixed graph of a complex.
  template <typename Complex> inline
  Graph<nothing,double> t_mixed_graph(const Complex& C, const graph& PG, const graph& DG, const double weigth);

} }

#include <t_graph.tcc>

#endif // _POLYMAKE_T_GRAPH_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
