#  Copyright (c) 1997-2006
#  Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
#  http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation; either version 2, or (at your option) any
#  later version: http://www.gnu.org/licenses/gpl.txt.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#-----------------------------------------------------------------------------
#  $Project: polymake $$Id: JavaViewStaticViewer.pm,v 1.8 2006/03/07 17:50:53 gawrilow Exp $

package JavaView::Viewer::Static;

###########################################################################################
#
#  Static (file-based) implementation of the Viewer interface
#
use BackgroundViewer;

use Struct [ '@ISA' => 'Poly::SimpleViewer' ];

sub new_drawing {
   my ($self, $title)=@_;
   $self->new_instance;
   $self->graphics=new JavaView::File($self->tempfile.".jvx", $title);
   $self;
}

sub append {
   shift->graphics->append(@_);
}

sub command {
   "$java -cp $classpath javaview CodeBase=$install_top " .
   shift->graphics->workfile;
}

1

# Local Variables:
# c-basic-offset:3
# End:
