//  $Project: polymake $$Id: polymake-scene.pov,v 1.1 1998/03/27 11:39:06 gawrilow Stab $

#version 3.0
#global_settings { assumed_gamma 1.0 }

#include "colors.inc"
#include "textures.inc"
#include "metals.inc"
#include "stones.inc"

#declare origin = <0,0,0>
#declare thick = 0.03

// Wolfram Schickenrieder
#declare Myglass = 
texture {
    pigment { color rgbf <0.98, 0.98, 0.98, 0.9> }
    finish  {
        ambient 0.1
        diffuse 0.1
        reflection 0.1
        refraction off
        ior 1
        specular 0.8
        roughness 0.0003
        phong 1 
        phong_size 400
     }
}

#declare My_Blue_Glass = 
texture {
    Myglass
    pigment { color rgbf <0.8, 0.8, 1, 0.9> }
}

#declare T_Polytope_wires =
  texture {
    pigment { color rgb <0.39, 0.41, 0.6> }
    finish { F_MetalC }
  }

#declare T_Polytope_solid = 
  texture {
    My_Blue_Glass
  }


// light near camera
light_source {
  <0, 1.6, -2.7>
  color White
  spotlight
  radius 20
  falloff 25
  tightness 10
  area_light <2, 0, 0>, <0, 0, 2>, 5, 5
  adaptive 1
  jitter
  point_at origin
}

//light from above
light_source {
  <1, 5, -2>
  color White
  spotlight
  radius 20
  falloff 25
  tightness 10
  area_light <1, 0, 0>, <0, 1, 0>, 1, 1
  adaptive 1
  jitter
  point_at origin
}

camera {
  location <0.2, 1.5, -2.7>
  right    <-1.33,0,0>
  look_at origin
}


plane { y, -2
  pigment { color PaleGreen }
  finish {
    reflection .35 specular 1
    ambient 0.6 diffuse 0.2 
  }
//  normal { ripples .35 turbulence .8  scale 3 }
}


// text {
//   ttf "timrom.ttf" "polymake" 0.10, 0
//   scale 0.4
//   pigment { Red }
//   rotate <90,0,0>
//   translate <-0.5,-1,-0.8>
// }
