#  Copyright (c) 1997-2006
#  Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
#  http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the
#  Free Software Foundation; either version 2, or (at your option) any
#  later version: http://www.gnu.org/licenses/gpl.txt.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#-----------------------------------------------------------------------------
#  $Project: polymake $$Id: utils.make,v 1.5.2.1 2006/03/13 11:00:06 gawrilow Exp $


PERL := perl
export PERL
PerlArch := $(shell eval `$(PERL) -V:archname -V:version`; echo $$archname $$version)
PerlVersion := $(word 2,$(PerlArch))
PerlArch := $(word 1,$(PerlArch))

ifndef BuildDir
  BuildDir := $(wildcard $(ProjectTop)/build)
endif
ifndef BuildDir
  ifeq "$(origin Arch)" "command line"
    BuildDir := $(wildcard $(ProjectTop)/build.$(Arch))
  else
    Machine := $(shell uname -m)
    Arch := $(Machine)
    BuildDir := $(wildcard $(ProjectTop)/build.$(Arch))
    ifndef BuildDir
      Arch := $(PerlArch)
      BuildDir := $(wildcard $(ProjectTop)/build.$(Arch))
    endif
    ifndef BuildDir
      ifeq "$(shell uname -s)" "Darwin"
        Arch := darwin
        BuildDir := $(wildcard $(ProjectTop)/build.$(Arch))
      else
        Arch := $(Machine)
      endif
    endif
  endif
  ifeq "$(BuildDir)$(_allow_lacking_BuildDir)" ""
    $(error BuildDir undefined)
  endif
endif

# recursively expand a variable which may contain names of other variables
_expand_var = $(foreach word,$(1),$(if $($(word)),$(call _expand_var,$($(word))), $(word)))

# convert a space-separated list into a colon-separated path
_empty:=
_space:=$(_empty) $(_empty)
_list2path = $(subst $(_space),:,$(strip $(1)))


# Local Variables:
# mode: Makefile
# End:
